# <in.H  Oned > out.H
#
#  Pass a 1-D signal thru streaming decon
#  
# keyword streaming decon
# JFC 
#%
integer n1, n2, na, nb, esize
from history:	integer n1, esize
from param:     integer na=3, nb=10
n2=2
to history:     integer n2
if (esize !=4)	call erexit('esize != 4')
allocate:	real           dd(n1), rr(n1), rb(nb), dr(nb), aa(na), da(na)


subroutine dumb(   n1, na, nb, dd,     rr,     rb,     dr,     aa,     da   )
real alpha, top, bot,          dd(n1), rr(n1), rb(nb), dr(nb), aa(na), da(na)
integer	           n1, na, nb
integer            ir, ia, ib
integer	iter, niter, nbmax, lag  # aa(lag)=1   
from param:     integer niter=2, lag=1    # Experiment while debugging 2-D.  Not recommended here.
call hclose()	# no more putch

call sreed(  'in', dd, 4*n1)

#  A block of temporary residuals reaches backwards on the inputs, so
#  the first of the block b(1) successively points at each permanent output residual rr(t).
#  The block may be truncated by its length, or by extending before a t=0 input.
#  The filter also reaches backwards for its inputs, so 
#  its contributions to the block also terminate when data is called from before a t=0 input.

do ia=1,na { aa(ia) = 0.}
aa(lag)=1.;
do ir = lag, n1 {
	do iter=1,niter	{
#	  MATH b = D a  (a is a PEF.  b is a box of residuals.  D is convolution with data.)
		do ib = 1, nb { rb(ib) = 0.}
		do ib = 1, min0(nb,ir)      {
		do ia = 1, min0(na,ir-ib+1) {
				rb(ib) += dd(ir-ib-ia+2) * aa(ia)
				} }				
		rr(ir-lag+1) = rb(1)     # Grab result!
				# This actually works when lag=2, but that refers to ir-1=0 (!)

					# If you prefer you could force zero output when ir<na.
#	  MATH da = D' b    (D' is adjoint D)
		do ia = 1, na { da(ia) = 0.}
		do ib = 1, min0(nb,ir)      {
		do ia = 1, min0(na,ir-ib+1) {
				da(ia) += dd(ir-ib-ia+2) * rb(ib)
				} }				
#	  MATH db = D da    (db is residual perturbation)
#		da(1) = 0.		# Constraint
		da(lag) = 0.		# Experiment while debugging 2-D.  Not recommended here.
		do ib = 1, nb { dr(ib) = 0.}
		do ib = 1, min0(nb,ir)    {
		do ia = 1, min0(na,ir-ib+1) {
				dr(ib) += dd(ir-ib-ia+2) * da(ia)
				} }				
# Some of your regression rows assume zero data off ends.  You may wish to omit those rows.
# It happens when ir<na.  To omit those rows, choose nbmax=min0(nb,ir-na).
# Then the output will equal the input in that region.
#	  MATH steepest descent
		nbmax = min0(nb,ir-na)
		nbmax =      nb
		top=0.;  bot=1.e-20
		do ib = 1, nbmax {
			top += rb(ib) * dr(ib) * (nb-ib+1)     # linear taper
			bot += dr(ib) * dr(ib) * (nb-ib+1)
			}
		alpha = -  top/bot
		do ia = 1, na {
			aa(ia) += alpha * da(ia)
			}
		}
	}
call srite( 'out', dd, 4*n1)
call srite( 'out', rr, 4*n1)					# XXX
return;	end

#	call snap('aa.H', na, 1, aa)					#  XXX
#call auxputch('label1','s','label1','bins.H')
#call auxputch('n2','i', n3,        'bins.H')
#call auxputch('d1','f', 1./nb,      'bins.H')
#	call snap('bins.H', nb,1,bins)
#      call snap('entropy.H', n3,1,entropy)
#	call srite('bins.H', bins, nb)
